/*global define, window, googleplus*/

define([
    'testsuite/qunit',
    'jquery',
    './googleplus-view',

    '$ready!'
], function (QUnit, $, GoogleplusView) {
    'use strict';

    QUnit.module('de_epages/externalcontent/ui/googleplus-view', {
        setup: function () {
            window.googleplus = new GoogleplusView();
            $('#qunit-fixture').append(googleplus.render().el);
        },
        teardown: function () {
            $('#qunit-fixture').empty();
        }
    });

    QUnit.test('Test googleplus view methods', 1, function () {
        $.each(['renderPreview'], function (i, method) {
            QUnit.equal(
                $.isFunction(googleplus[method]),
                true,
                method + ' is a method of googleplus-view'
            );
        });
    });

    QUnit.test('Test googleplus settings', 3, function () {

        QUnit.equal(
            $('#qunit-fixture').children().length,
            1,
            'Create googleplus view'
        );

        QUnit.deepEqual(
            googleplus.gOptions,
            {layout: "standard", type: "bubble"},
            "Get default options"
        );

        $('#layout').val('small').trigger('change');
        $('#type').val('none').trigger('change');

        QUnit.deepEqual(
            googleplus.gOptions,
            {layout: "small", type: "none"},
            "Change options"
        );
    });
});