/*
 * @copyright		© Copyright 2006-2013, epages GmbH, All Rights Reserved.
 *
 * @module			de_epages/shop/inc/openwindowmobile
 *
 * @revision		$Revision: 1.4 $
 */

define("de_epages/shop/inc/openwindowmobile", [
	"jquery",
	"ep",

	"ep/openwindow"
], function ($, ep) {

	return {
		mobilePreview: function (options) {
			var defaults = $.extend({
					//	MerchantSFSession: undefined,
					mSFLinkSelector: ".ep-mobile-storefront-link",
					ShopID: 1,
					ClosedByMerchant: false,
					ChangeObjectPath: '',
					DebugLevel: 0,
					UseMobileSF: true
				}, options);

			if (defaults.ClosedByMerchant) {
				// console.debug(defaults.ChangeObjectPath);
				// set cookie to show mobile sf also if shop is closed
				$.ajax({
					url: '?',
					type: 'post',
					data: 'IsMobile=1&ChangeAction=SetAdminCookie&ChangeObjectPath=' + defaults.ChangeObjectPath + '&MerchantSFSession=' + defaults.MerchantSFSession
				});
			}

			$(defaults.mSFLinkSelector)
				.on("click", function (evt) {
					if (defaults.DebugLevel == 0) {
						if (pageCache_Publish) {
							pageCache_Publish(ep.openMobileWindow($(this).data('href'), defaults, {
								mSFLinkSelector: defaults.mSFLinkSelector
							}));
						}
						else {
							ep.openMobileWindow($(this).data('href'), defaults, {
								mSFLinkSelector: defaults.mSFLinkSelector
							});
						}
					}
					else {
						ep.openMobileWindow($(this).data('href'), defaults, {
							mSFLinkSelector: defaults.mSFLinkSelector
						});
					}
				});
		}
	};

});