/*global define, CKEDITOR, setTimeout, document*/
/*jslint vars: true*/
define(['ep/ui/editor', 'testsuite/qunit', 'jquery', '$ready!'], function (ep, QUnit, $) {
    'use strict';
    QUnit.module("ckeditor/plugins/epcolorbutton");

    function cke_test(instance, openselector, closeselector, setfunction, testfunction) {
        $(openselector).trigger('click');
        setTimeout(function () {
            setfunction();
            setTimeout(function () {
                $(closeselector).trigger('click');
                setTimeout(function () {
                    var data = instance.getData();
                    testfunction(data);
                }, 500);
            }, 500);
        }, 2000);
    }

    function selectElementById(id, editorInstance) {
        editorInstance.getSelection().selectElement(editorInstance.document.getById(id));
        return;
    }

    QUnit.asyncTest("link picker test", function () {

        ep('#uieditor_ckeditortestinstance').val("");
        ep('#uieditor_ckeditortestinstance').uiEditor({});

        setTimeout(function () {
            var editor = CKEDITOR.instances.uieditor_ckeditortestinstance,
                input = 'foobar',
                id = input + "_01";

            // insert content
            editor.insertHtml('<span id="' + id + '">' + input + '</span>');

            setTimeout(function () {
                // Perform listformattings on p-tags.
                selectElementById(id, editor);

                editor.focus();

                setTimeout(function () {
                    cke_test(CKEDITOR.instances.uieditor_ckeditortestinstance,
                        '.cke_button__eplink_icon', '.ep-uiColorpicker-applyButton',
                        function () {
                            QUnit.ok($('.linkpickerDialog:visible').length === 1, 'Linkpicker is visible');
                            $('a[href=#ep-linkpicker-externalwebsite]').trigger('click');


                            $('#ep-linkpicker-externalUrl').val('http://example.com').trigger('keyup');
                            $('.ui-dialog-buttonset :nth-child(1)').eq(0).trigger('click');

                        },
                        function (data) {
                            var elem = $(editor.getData());
                            QUnit.equal($(elem.find('a')).attr('href'), 'http://example.com', 'Link to http://example.com');
                            QUnit.ok($('.linkpickerDialog:visible').length === 0, 'Linkpicker is not visible');

                            editor.execCommand('eplink');

                            setTimeout(function () {
                                QUnit.ok($('.linkpickerDialog:visible').length === 1, 'Linkpicker is visible');
                                QUnit.ok($('#ep-linkpicker-linkText').val() === 'foobar', 'Linkpicker title is foobar');
                                QUnit.ok($('#ep-linkpicker-externalUrl').val() === 'http://example.com', 'Linkpicker url is http://example.com');
                                $('.ui-dialog-buttonset :nth-child(1)').eq(0).trigger('click');
                                ep('#uieditor_ckeditortestinstance').uiEditor('destroy');
                                QUnit.start();
                            }, 200);
                        });
                }, 500);
            }, 1500);
        }, 2000);
    });
});